function [N_ind] = indep_samples(data)
  
   % Initalise the autocorrelation function 
   R = zeros(length(data),1);
   
   % Remove the mean value of data
   data = data - nanmean(data);

   tau = 0; % tau counter
   R_sign = 1; % positive
   
   % Calculate R(tau) starting at R(0) and stopping when it becomes negative
   while R_sign >= 0 && tau < length(data)
         
        tau = tau+1;
        N = length(data)-(tau-1); % number of data points used in
                                             %this iteration
        for t = 1:N
           int = data(t).*data(t+tau-1);
           if isfinite(int) == true % only sum if int is real 
             R(tau) = R(tau) + int;
           else 
             R(tau) = R(tau);
           end 
       end
       R(tau) = R(tau)/N;                 % divide R by number of data
                                          % points - should this be N-1?
       R_sign = sign(R(tau));             % the sign of R(tau) want to
                                          % continue if R(tau) is positive
    end 

    R = R./(nanstd(data))^2;             % normalise R by the variance
    
    % Calculate the number of independent samples
    N_ind = 0.5*length(data)/nansum(R(1:(tau-1)));