%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% indep_samples_fft.m                                                    %
%                                                                        %
% Copyright (c) 2012-2013 Natalie Harvey and the University of Reading   %
%                                                                        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [N_ind] = indep_samples_fft(data)
  
   % Initalise the autocorrelation function 
   R = zeros(length(data)*2,1);
   
   % Remove the mean value of data
   data = data - nanmean(data);

   tau = 0; % tau counter
   R_sign = 1; % positive
   
   n = length(data);
   fdata = fft([data; zeros(n,1)]);
   fR = fdata.*conj(fdata);
   R = ifft(fR)/(n*var(data));
   
   % Calculate R(tau) starting at R(0) and stopping when it becomes negative
   while R_sign >= 0 && tau < length(data)
     tau = tau+1;
     R_sign = sign(R(tau));             % the sign of R(tau) want to
                                        % continue if R(tau) is positive
    end

    % Calculate the number of independent samples
    N_ind = 0.5*length(data)/nansum(R(1:(tau-1)));
